package top.continew.admin.system.service;

import top.continew.admin.system.model.entity.UserRoleDO;

import java.util.List;

/**
 * 用户和角色业务接口
 *
 * @author Charles7c
 * @since 2023/2/20 21:30
 */
public interface UserRoleService {

    /**
     * 新增
     *
     * @param roleIds 角色 ID 列表
     * @param userId  用户 ID
     * @return 是否新增成功（true：成功；false：无变更/失败）
     */
    boolean add(List<Long> roleIds, Long userId);

    /**
     * 根据用户 ID 删除
     *
     * @param userIds 用户 ID 列表
     */
    void deleteByUserIds(List<Long> userIds);

    /**
     * 批量插入
     *
     * @param list 数据集
     */
    void saveBatch(List<UserRoleDO> list);

    /**
     * 根据用户 ID 查询
     *
     * @param userId 用户 ID
     * @return 角色 ID 列表
     */
    List<Long> listRoleIdByUserId(Long userId);

    /**
     * 根据角色 ID 判断是否已被用户关联
     *
     * @param roleIds 角色 ID 列表
     * @return 是否已关联（true：已关联；false：未关联）
     */
    boolean isRoleIdExists(List<Long> roleIds);
}